package com.bocloud.pms.entity;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.annotation.JSONField;
import com.bocloud.entity.bean.GenericEntity;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

/**
 * Created by liuyuanyuan on 2020/3/18 9:51
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = true)
public class CmsConnection extends GenericEntity {
    private String vhost;
    private String name;
    private String user;
    private String state;
    private Boolean ssl;
    private String protocol;
    private String channels;
    //速率单位B/s
    @JSONField(name = "recv_oct_details")
    private JSONObject recvOctDetails;
    //速率单位B/s
    @JSONField(name = "send_oct_details")
    private JSONObject sendOctDetails;
    @JSONField(name = "client_properties")
    private JSONObject clientProperties;
    @JSONField(name = "connected_at")
    private String connectedAt;
    @JSONField(name = "auth_mechanism")
    private String authMechanism;
    private Long timeout;
    @JSONField(name = "frame_max")
    private Long frameMax;
    @JSONField(name = "channel_max")
    private Long channelMax;
    @JSONField(name = "peer_host")
    private String peerHost;
    @JSONField(name = "peer_port")
    private Long peerPort;
    @JSONField(name = "X-Reason")
    private String xReason;
    private Long fromClient;
    private Long toClient;
    private String clientProvidedName;
}
