package com.bocloud.pms.entity;

import com.bocloud.entity.annotations.Column;
import com.bocloud.entity.annotations.PK;
import com.bocloud.entity.annotations.Table;
import com.bocloud.entity.bean.Generic;
import com.bocloud.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

/**
 * 数据库节点
 * 
 * @author weiwei
 *
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Table("rds_node")
public class RdsNode extends Generic {

	@PK(PKStrategy.AUTO)
	private Long id;// ID
	@Column("address")
	private String address;// 节点地址
	@Column("port")
	private Integer port;// 节点端口
	@Column("role")
	private String role;// 节点角色
	@Column("status")
	private String status;// 节点状态
	@Column("instance_id")
	private String instanceId;// 关联的云主机实例ID
	@Column("server_id")
	private Long serverId;// 关联的云主机ID
	@Column("rds_id")
	private Long rdsId;// 数据库服务ID
	@Column("manage_ip")
	private String manageIp;
	@Column("group_id")
	private String groupId;

	/**
	 * 
	 * @param address
	 * @param port
	 * @param role
	 * @param status
	 * @param instanceId
	 * @param rdsId
	 */
	public RdsNode(String address, Integer port, String role, String status, String instanceId, Long rdsId) {
		super();
		this.address = address;
		this.port = port;
		this.role = role;
		this.status = status;
		this.instanceId = instanceId;
		this.rdsId = rdsId;
	}
}
