package com.bocloud.pms.entity.resource;

import com.bocloud.entity.annotations.Column;
import com.bocloud.entity.annotations.PK;
import com.bocloud.entity.annotations.Table;
import com.bocloud.entity.bean.GenericEntity;
import com.bocloud.entity.meta.PKStrategy;

/**
 * 存储中心文件
 *
 * @author hufy
 * @since
 */
@Table("data_store_file")
public class DataStoreFile extends GenericEntity {

    @PK(value = PKStrategy.AUTO)
    private Long id;
    /**
     * vdc id
     */
    @Column("vdc_id")
    private Long vdcId;

    /**
     * vdc id
     */
    @Column("host_id")
    private Long hostId;
    /**
     * 云供应商id
     */
    @Column("vendor_id")
    private Long vendorId; // 云供应商ID
    /**
     * 存储id
     */
    @Column("store_id")
    private Long storeId;

    @Column("size")
    private Long size;


    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getVdcId() {
        return vdcId;
    }

    public void setVdcId(Long vdcId) {
        this.vdcId = vdcId;
    }

    public Long getVendorId() {
        return vendorId;
    }

    public void setVendorId(Long vendorId) {
        this.vendorId = vendorId;
    }

    public Long getStoreId() {
        return storeId;
    }

    public void setStoreId(Long storeId) {
        this.storeId = storeId;
    }

    public Long getHostId() {
        return hostId;
    }

    public void setHostId(Long hostId) {
        this.hostId = hostId;
    }

    public Long getSize() {
        return size;
    }

    public void setSize(Long size) {
        this.size = size;
    }

    public DataStoreFile() {
        super();
    }

    public DataStoreFile(Long creatorId, Long ownerId, Long menderId, String name, String status, Boolean deleted,
                         String props, String remark) {
        super();
        this.setCreatorId(creatorId);
        this.setOwnerId(ownerId);
        this.setMenderId(menderId);
        this.setName(name);
        this.setStatus(status);
        this.setDeleted(deleted);
        this.setProps(props);
        this.setRemark(remark);
    }

    public DataStoreFile(Long creatorId, Long ownerId, Long menderId) {
        super();
        this.setCreatorId(creatorId);
        this.setOwnerId(ownerId);
        this.setMenderId(menderId);
    }

    public void preSave(Long creatorId, Long menderId, Long vendorId, Long vdcId, Long hostId, Long storeId) {
        this.setCreatorId(creatorId);
        this.setMenderId(menderId);
        this.setVendorId(vendorId);
        this.setVdcId(vdcId);
        this.setHostId(hostId);
        this.setStoreId(storeId);
    }
}
