package com.bocloud.pms.entity.resource;

import com.bocloud.entity.annotations.Column;
import com.bocloud.entity.annotations.IgnoreAll;
import com.bocloud.entity.annotations.PK;
import com.bocloud.entity.annotations.Table;
import com.bocloud.entity.bean.Generic;
import com.bocloud.entity.meta.PKStrategy;

import java.math.BigDecimal;

/**
 * 配置实体类
 *
 * @author dongkai
 */
@Table("flavor")
public class Flavor extends Generic {

    @PK(value = PKStrategy.AUTO)
    private Long id; // ID
    @Column("name")
    private String name; // 名称
    @Column("flavor_uuid")
    private String flavorUuid; // 配置的ID
    @Column("memory")
    private BigDecimal memory; // RAM
    @Column("cpu")
    private Integer cpu; // CPU
    @Column("disk")
    private Integer disk; // 磁盘
    @Column("vendor_id")
    private Long vendorId; // 云供应商ID
    @IgnoreAll
    private String vendorName; // 云供应商名称
    @Column("family")
    private String family;// 规格族
    @Column("performance_type")
    private String performanceType;

    @Column("status")
    private String status; // 状态
    @Column("instance_charge_type")
    private String instanceChargeType; // 付费类型
    @Column("zone")
    private String zone; // 区域

    @Column("extra_specs_id")
    private Long extraSpecsId; // 对应在flavor_extra_specs表中的ID

    @Column("region_id")
    private String regionId;
    @IgnoreAll
    private String regionName;
    @IgnoreAll
    private String zoneName;
    @IgnoreAll
    private FlavorExtraSpecs extraSpecs;

    /**
     * @return the family
     */
    public String getFamily() {
        return family;
    }

    /**
     * @param family the family to set
     */
    public void setFamily(String family) {
        this.family = family;
    }

    /**
     * @return the vendorName
     */
    public String getVendorName() {
        return vendorName;
    }

    /**
     * @param vendorName the vendorName to set
     */
    public void setVendorName(String vendorName) {
        this.vendorName = vendorName;
    }

    /**
     * @return the vendorId
     */
    public Long getVendorId() {
        return vendorId;
    }

    /**
     * @param vendorId the vendorId to set
     */
    public void setVendorId(Long vendorId) {
        this.vendorId = vendorId;
    }

    /**
     * @return the id
     */
    public Long getId() {
        return id;
    }

    /**
     * @param id the id to set
     */
    public void setId(Long id) {
        this.id = id;
    }

    /**
     * @return the name
     */
    public String getName() {
        return name;
    }

    /**
     * @param name the name to set
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * @return the flavorUuid
     */
    public String getFlavorUuid() {
        return flavorUuid;
    }

    /**
     * @param flavorUuid the flavorUuid to set
     */
    public void setFlavorUuid(String flavorUuid) {
        this.flavorUuid = flavorUuid;
    }

    public BigDecimal getMemory() {
        return memory;
    }

    public void setMemory(BigDecimal memory) {
        this.memory = memory;
    }

    /**
     * @return the cpu
     */
    public Integer getCpu() {
        return cpu;
    }

    /**
     * @param cpu the cpu to set
     */
    public void setCpu(Integer cpu) {
        this.cpu = cpu;
    }

    /**
     * @return the disk
     */
    public Integer getDisk() {
        return disk;
    }

    /**
     * @param disk the disk to set
     */
    public void setDisk(Integer disk) {
        this.disk = disk;
    }

    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    public String getInstanceChargeType() {
        return instanceChargeType;
    }

    public void setInstanceChargeType(String instanceChargeType) {
        this.instanceChargeType = instanceChargeType;
    }

    public String getZone() {
        return zone;
    }

    public void setZone(String zone) {
        this.zone = zone;
    }

    public String getZoneName() {
        return zoneName;
    }

    public void setZoneName(String zoneName) {
        this.zoneName = zoneName;
    }

    public String getRegionId() {
        return regionId;
    }

    public void setRegionId(String regionId) {
        this.regionId = regionId;
    }

    public String getRegionName() {
        return regionName;
    }

    public void setRegionName(String regionName) {
        this.regionName = regionName;
    }

    public Long getExtraSpecsId() {
        return extraSpecsId;
    }

    public void setExtraSpecsId(Long extraSpecsId) {
        this.extraSpecsId = extraSpecsId;
    }

    public FlavorExtraSpecs getExtraSpecs() {
        return extraSpecs;
    }

    public void setExtraSpecs(FlavorExtraSpecs extraSpecs) {
        this.extraSpecs = extraSpecs;
    }

    public String getPerformanceType() {
        return performanceType;
    }

    public void setPerformanceType(String performanceType) {
        this.performanceType = performanceType;
    }

}
