package com.bocloud.pms.entity.resource;

import com.bocloud.entity.annotations.Column;
import com.bocloud.entity.annotations.IgnoreAll;
import com.bocloud.entity.annotations.PK;
import com.bocloud.entity.annotations.Table;
import com.bocloud.entity.bean.GenericEntity;
import com.bocloud.entity.meta.PKStrategy;

@Table("network_card")
public class NetworkCard extends GenericEntity {

	@PK(value = PKStrategy.AUTO)
	private Long id;
	@Column("used")
	private Boolean used;// 网卡在某一台物理机上是否被使用
	@Column("host_id")
	private Long hostId;
	@Column("vendor_id")
	private Long vendorId;
	@Column("mac")
	private String mac;
	/**
	 * VM or PM
	 */
	@Column("category")
	private String category;
	/**
	 * for vm, label is 'Network adapter 1' for pm, label is null
	 */
	@Column("label")
	private String label;
	@Column("switcher_id")
	private Long switcherId;
	/**
	 * for vm, portType is 'VIRTUAL' for pm, portType is eth....
	 */
	@Column("port_type")
	private String portType;// 端口类型
	@Column("pci_id")
	private Long pciId;
	@IgnoreAll
	private String switcher;
	@Column("region_id")
	private String regionId;
	@IgnoreAll
	private String regionName;

	@Column("zone")
	private String zone;
	@IgnoreAll
	private String zoneName;
	@Column("vpc_uuid")
	private String vpcUuid;

	@Column("subnet_uuid")
	private String subnetUuid;
	@Column("networkcard_uuid")
	private String networkcardUuid;
	@Column("is_primary")
	private Boolean isPrimary;
	@Column("ip_address")
	private String ipAddress;

	@Column("floatingip_uuid")
	private String floatingIpUuid;
	@Column("instance_id")
	private String instanceId;

	/**
	 * 网卡mtu数据
	 * <p>
	 * 1500
	 */
	@Column("mtu")
	private Integer mtu;
	/**
	 * 网卡下表编号 0，1，2，3
	 */
	@Column("number")
	private Integer number;

	@IgnoreAll
	private String vpcName;
	@IgnoreAll
	private String subnetName;
	@IgnoreAll
	private String serverName;

	@IgnoreAll
	private String floatingIp;


	public String getFloatingIp() {
		return floatingIp;
	}

	public void setFloatingIp(String floatingIp) {
		this.floatingIp = floatingIp;
	}

	/**
	 * @return the id
	 */
	public Long getId() {
		return id;
	}

	/**
	 * @param id
	 *            the id to set
	 */
	public void setId(Long id) {
		this.id = id;
	}

	/**
	 * @return the used
	 */
	public Boolean getUsed() {
		return used;
	}

	/**
	 * @param used
	 *            the used to set
	 */
	public void setUsed(Boolean used) {
		this.used = used;
	}

	/**
	 * @return the hostId
	 */
	public Long getHostId() {
		return hostId;
	}

	/**
	 * @param hostId
	 *            the hostId to set
	 */
	public void setHostId(Long hostId) {
		this.hostId = hostId;
	}

	/**
	 * @return the vendorId
	 */
	public Long getVendorId() {
		return vendorId;
	}

	/**
	 * @param vendorId
	 *            the vendorId to set
	 */
	public void setVendorId(Long vendorId) {
		this.vendorId = vendorId;
	}

	/**
	 * @return the mac
	 */
	public String getMac() {
		return mac;
	}

	/**
	 * @param mac
	 *            the mac to set
	 */
	public void setMac(String mac) {
		this.mac = mac;
	}

	/**
	 * @return the category
	 */
	public String getCategory() {
		return category;
	}

	/**
	 * @param category
	 *            the category to set
	 */
	public void setCategory(String category) {
		this.category = category;
	}

	/**
	 * @return the label
	 */
	public String getLabel() {
		return label;
	}

	/**
	 * @param label
	 *            the label to set
	 */
	public void setLabel(String label) {
		this.label = label;
	}

	/**
	 * @return the switcherId
	 */
	public Long getSwitcherId() {
		return switcherId;
	}

	/**
	 * @param switcherId
	 *            the switcherId to set
	 */
	public void setSwitcherId(Long switcherId) {
		this.switcherId = switcherId;
	}

	/**
	 * @return the switcher
	 */
	public String getSwitcher() {
		return switcher;
	}

	/**
	 * @param switcher
	 *            the switcher to set
	 */
	public void setSwitcher(String switcher) {
		this.switcher = switcher;
	}

	/**
	 * @return the portType
	 */
	public String getPortType() {
		return portType;
	}

	/**
	 * @param portType
	 *            the portType to set
	 */
	public void setPortType(String portType) {
		this.portType = portType;
	}

	public Long getPciId() {
		return pciId;
	}

	public void setPciId(Long pciId) {
		this.pciId = pciId;
	}

	public void preSave(Long creatorId, Long menderId, Long vendorId, Long hostId, String category) {
		this.setCreatorId(creatorId);
		this.setMenderId(menderId);
		this.setVendorId(vendorId);
		this.setHostId(hostId);
		this.setCategory(category);
	}

	public String getRegionId() {
		return regionId;
	}

	public void setRegionId(String regionId) {
		this.regionId = regionId;
	}

	public String getRegionName() {
		return regionName;
	}

	public void setRegionName(String regionName) {
		this.regionName = regionName;
	}

	public Integer getMtu() {
		return mtu;
	}

	public void setMtu(Integer mtu) {
		this.mtu = mtu;
	}

	public Integer getNumber() {
		return number;
	}

	public void setNumber(Integer number) {
		this.number = number;
	}

	public String getZone() {
		return zone;
	}

	public void setZone(String zone) {
		this.zone = zone;
	}

	public String getZoneName() {
		return zoneName;
	}

	public void setZoneName(String zoneName) {
		this.zoneName = zoneName;
	}

	public String getVpcUuid() {
		return vpcUuid;
	}

	public void setVpcUuid(String vpcUuid) {
		this.vpcUuid = vpcUuid;
	}

	public String getSubnetUuid() {
		return subnetUuid;
	}

	public void setSubnetUuid(String subnetUuid) {
		this.subnetUuid = subnetUuid;
	}

	public String getNetworkcardUuid() {
		return networkcardUuid;
	}

	public void setNetworkcardUuid(String networkcardUuid) {
		this.networkcardUuid = networkcardUuid;
	}

	public Boolean getIsPrimary() {
		return isPrimary;
	}

	public void setIsPrimary(Boolean isPrimary) {
		this.isPrimary = isPrimary;
	}

	public String getIpAddress() {
		return ipAddress;
	}

	public void setIpAddress(String ipAddress) {
		this.ipAddress = ipAddress;
	}

	public String getVpcName() {
		return vpcName;
	}

	public void setVpcName(String vpcName) {
		this.vpcName = vpcName;
	}

	public String getSubnetName() {
		return subnetName;
	}

	public void setSubnetName(String subnetName) {
		this.subnetName = subnetName;
	}

	public String getServerName() {
		return serverName;
	}

	public void setServerName(String serverName) {
		this.serverName = serverName;
	}

	public String getFloatingIpUuid() {
		return floatingIpUuid;
	}

	public void setFloatingIpUuid(String floatingIpUuid) {
		this.floatingIpUuid = floatingIpUuid;
	}

	public String getInstanceId() {
		return instanceId;
	}

	public void setInstanceId(String instanceId) {
		this.instanceId = instanceId;
	}

}
