package com.bocloud.pms.entity.resource;

import com.bocloud.entity.annotations.Column;
import com.bocloud.entity.annotations.PK;
import com.bocloud.entity.annotations.Table;
import com.bocloud.entity.bean.Generic;
import com.bocloud.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

/**
 * 用户与项目之间的关系表
 */
@Table("user_project")
@Data
@EqualsAndHashCode(callSuper = true)
@NoArgsConstructor
@AllArgsConstructor
public class UserProject extends Generic {
    @PK(value = PKStrategy.AUTO)
    private Long id;
    @Column("user_id")
    private Long userId;
    @Column("project_id")
    private Long projectId;
    @Column("project_role")
    private String projectRole;

    public UserProject(Long userId, Long projectId, String projectRole) {
        this.userId = userId;
        this.projectId = projectId;
        this.projectRole = projectRole;
    }

    public enum category {
        /**
         * 项目成员
         */
        member,
        /**
         * 项目经理
         */
        manager,
        /**
         * 供应商经理
         */
        provider
    }
}