package com.bocloud.pms.entity.resource.enums;

/**
 * 计费公共枚举
 * 
 * @author wangyu
 * @version 1.0
 * @since 2020年3月16日
 *
 */
public class ChargeCommon {

	/**
	 * 计费模式
	 * 
	 * @author wangyu
	 * @version 1.0
	 * @since 2020年3月16日
	 *
	 */
	public enum ChargeMode {
		PreCharge, // 预付费
		PostCharge// 后付费
	}

	/**
	 * 订单资源状态
	 * 
	 * @author wangyu
	 * @version 1.0
	 * @since 2020年3月16日
	 *
	 */
	public enum ResourceStatus {
		creating, // 创建中
		ready, // 创建完成
		failed, // 创建失败
		exception, // 创建异常
		canceld;// 已取消
	}

	/**
	 * 订单状态
	 * 
	 * @author wangyu
	 * @version 1.0
	 * @since 2020年3月16日
	 *
	 */
	public enum OrderStatus {
		unpay, // 未支付
		paid, // 已支付
		canceld// 已取消
	}

	/**
	 * 
	 * @author wangyu
	 * @version 1.0
	 * @since 2020年4月14日
	 *
	 */
	public enum BillStatus {
		unpay, // 未支付
		paid, // 已支付
		paying, // 支付中
		canceld// 已取消
	}

}
