package com.bocloud.pms.interfaces.middleware;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.common.model.*;
import com.bocloud.pms.entity.Ccs;

import java.util.List;
import java.util.Map;

public interface CcsService {

    /**
     * 列表展示
     *
     * @param pager
     * @param context
     * @return
     */
    public BocloudResult<GridBean<Ccs>> list(Pager pager, RequestContext context);

    /**
     * 添加
     *
     * @param params
     * @param context
     * @return
     */
    public BocloudResult create(String params, RequestContext context);

    /**
     * 详情
     *
     * @param id
     * @return
     */
    public BocloudResult<Ccs> detail(Long id);

    /**
     * 基础信息
     *
     * @param id
     * @return
     */
    public BocloudResult<Ccs> basics(Long id);

    /**
     * 删除
     *
     * @param id
     * @param context
     * @return
     */
    public BocloudResult remove(Long id, RequestContext context);

    /**
     * 记录安装
     *
     * @param params
     * @param context
     * @return
     */
    public void install(String params, RequestContext context);

    /**
     * 同步角色状态
     *
     * @param content
     */
    public void synchronousRoleState(JSONObject content);

}
