package com.bocloud.pms.interfaces.middleware;

import com.bocloud.common.model.BocloudResult;
import com.bocloud.common.model.GridBean;
import com.bocloud.common.model.Pager;
import com.bocloud.pms.entity.CmsUser;
import com.bocloud.pms.entity.CmsVhost;

import java.util.List;

/**
 * Created by liuyuanyuan on 2020/3/11 18:02
 */
public interface CmsManageService {

    /**
     * 列表
     *
     * @param mqId
     * @param pager
     * @return
     */
    public BocloudResult<GridBean<CmsVhost>> listOfVhost(Long mqId, Pager pager);

    /**
     * 添加mqVhost
     *
     * @param mqVhost
     * @param mqId
     * @return
     */
    public BocloudResult create(CmsVhost mqVhost, Long mqId);

    /**
     * 删除mqVhost
     *
     * @param mqId
     * @param vhostName
     * @return
     */
    public BocloudResult removeVhost(Long mqId, String vhostName);

    /**
     * 详情
     *
     * @param mqId
     * @param vhostName
     * @return
     */
    public BocloudResult<CmsVhost> detailOfVhost(Long mqId, String vhostName);

    /**
     * vhost权限列表
     *
     * @param mqId
     * @param vhostName
     * @return
     */
    public BocloudResult<List<CmsVhost>> permissionOfVhostOfList(Long mqId, String vhostName);

    /**
     * 设置vhost权限
     *
     * @param mqId
     * @param vhostName
     * @param mqVhost
     * @return
     */
    public BocloudResult createPermissionOfVhost(Long mqId, String vhostName, CmsVhost mqVhost);

    /**
     * vhost权限清除
     *
     * @param mqId
     * @param vhostName
     * @return
     */
    public BocloudResult deletePermissionOfVhost(Long mqId, String vhostName, String userName);

    /**
     * 用户权限列表
     *
     * @param mqId
     * @param userName
     * @return
     */
    public BocloudResult<List<CmsUser>> permissionOfUserOfList(Long mqId, String userName);

    /**
     * 用户权限设置
     *
     * @param mqId
     * @param userName
     * @param mqUser
     * @return
     */
    public BocloudResult createPermissionOfUser(Long mqId, String userName, CmsUser mqUser);

    /**
     * 用户权限设置
     *
     * @param mqId
     * @param usertName
     * @return
     */
    public BocloudResult deletePermissionOfUser(Long mqId, String usertName, String vhostName);

    /**
     * 列表
     *
     * @param mqId
     * @param pager
     * @return
     */
    public BocloudResult<GridBean<CmsUser>> listOfUser(Long mqId, Pager pager);

    /**
     * 添加user
     *
     * @param mqUser
     * @param mqId
     * @return
     */
    public BocloudResult create(Long mqId, CmsUser mqUser);

    /**
     * 删除user
     *
     * @param id
     * @param userName
     * @return
     */
    public BocloudResult removeUser(Long id, String userName);

    /**
     * 更新user
     *
     * @param mqUser
     * @param mqId
     * @return
     */
    public BocloudResult updateUser(Long mqId, CmsUser mqUser);

    /**
     * 详情
     *
     * @param mqId
     * @param userName
     * @return
     */
    public BocloudResult<CmsUser> detailOfUser(Long mqId, String userName);
}