package com.bocloud.pms.interfaces.middleware;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.common.model.*;
import com.bocloud.pms.entity.Lbs;

import java.util.List;
import java.util.Map;

public interface LbsService {

    /**
     * 列表展示
     *
     * @param pager
     * @return
     */
    public BocloudResult<GridBean<Lbs>> list(Pager pager, RequestContext context);

    /**
     * 添加
     *
     * @param params
     * @param context
     * @return
     */
    public BocloudResult create(String params, RequestContext context);

    /**
     * 详情
     *
     * @param id
     * @return
     */
    public BocloudResult<Lbs> detail(Long id);

    /**
     * 删除
     *
     * @param id
     * @param context
     * @return
     */
    public BocloudResult remove(Long id, RequestContext context);

    /**
     * 记录安装
     *
     * @param params
     * @param context
     * @return
     */
    public void install(String params, RequestContext context);

    /**
     * 同步角色状态
     *
     * @param content
     */
    public void synchronousRoleState(JSONObject content);

    /**
     * 加入回收站
     *
     * @param id
     * @param context
     * @return
     */
    public BocloudResult recycle(Long id, RequestContext context);

    /**
     * 回收站还原
     *
     * @param id
     * @param context
     * @return
     */
    public BocloudResult restore(Long id, RequestContext context);

}
