package com.bocloud.pms.interfaces.middleware;

import com.bocloud.common.model.*;
import com.bocloud.pms.entity.RdsUser;

import java.util.List;
import java.util.Map;

public interface RdsUserService {

    /**
     * 列表展示
     *
     * @param pager
     * @param context
     * @return
     */
    public BocloudResult<GridBean<RdsUser>> list(Pager pager, RequestContext context);

    /**
     * 申请
     *
     * @param rdsUser
     * @param context
     * @return
     */
    public BocloudResult create(RdsUser rdsUser, RequestContext context);

    /**
     * 删除
     *
     * @param id
     * @param context
     * @return
     */
    public BocloudResult remove(Long id, RequestContext context);

    /**
     * 详情
     *
     * @param id
     * @return
     */
    public BocloudResult<RdsUser> detail(Long id);

    /**
     * 重置密码
     *
     * @param rdsUser
     * @param context
     * @return
     */
    public BocloudResult reset(RdsUser rdsUser, RequestContext context);

    /**
     * 授权
     *
     * @param rdsUser
     * @param context
     * @return
     */
    public BocloudResult grant(RdsUser rdsUser, RequestContext context);

    /**
     * 撤权
     *
     * @param id
     * @param context
     * @return
     */
    public BocloudResult revoke(Long id, RequestContext context);

}
