package com.bocloud.pms.repository;

import com.bocloud.common.utils.MapTools;
import com.bocloud.database.core.intf.impl.BasicGenericDao;
import com.bocloud.pms.entity.AssNode;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
 * 应用服务节点Repository接口实现
 *
 * @author weiwei
 */
@Repository("assNodeRepository")
public class AssNodeRepository extends BasicGenericDao<AssNode, Long> {

    public AssNodeRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate npJdbcTemplate) {
        super(jdbcTemplate, npJdbcTemplate);
    }

    public List<AssNode> list(Long assId) throws Exception {
        String sql = "select * from ass_node where ass_id = :assId";
        Map<String, Object> params = MapTools.simpleMap("assId", assId);
        return this.list(AssNode.class, sql, params);
    }

    public boolean deleteByAss(Long assId) throws Exception {
        String sql = "delete from ass_node where ass_id = :assId";
        Map<String, Object> params = MapTools.simpleMap("assId", assId);
        return this.execute(sql, params) > 0;
    }

    public AssNode query(Long id) throws Exception {
        String sql = "select * from ass_node where id = :id";
        Map<String, Object> params = MapTools.simpleMap("id", id);
        List<AssNode> list = this.list(AssNode.class, sql, params);
        return list.isEmpty() ? null : list.get(0);
    }

    public boolean batchUpdate(List<AssNode> nodes) throws Exception {
        return this.batchUpdate(nodes, nodes.size());
    }
}
