package com.bocloud.pms.repository;

import com.bocloud.common.utils.MapTools;
import com.bocloud.database.core.intf.impl.BasicGenericDao;
import com.bocloud.pms.entity.CcsNode;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
 * 配置中心节点Repository接口实现
 *
 * @author weiwei
 */
@Repository("ccsNodeRepository")
public class CcsNodeRepository extends BasicGenericDao<CcsNode, Long> {

	public CcsNodeRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate npJdbcTemplate) {
		super(jdbcTemplate, npJdbcTemplate);
	}

	public List<CcsNode> list(Long ccsId) throws Exception {
		String sql = "select * from ccs_node where ccs_id = :ccsId";
		Map<String, Object> params = MapTools.simpleMap("ccsId", ccsId);
		return this.list(CcsNode.class, sql, params);
	}

	public boolean deleteByCcs(Long ccsId) throws Exception {
		String sql = "delete from ccs_node where ccs_id = :ccsId";
		Map<String, Object> params = MapTools.simpleMap("ccsId", ccsId);
		return this.execute(sql, params) > 0;
	}

	public CcsNode query(Long id) throws Exception {
		String sql = "select * from ccs_node where id = :id";
		Map<String, Object> params = MapTools.simpleMap("id", id);
		List<CcsNode> list = this.list(CcsNode.class, sql, params);
		return list.isEmpty() ? null : list.get(0);
	}

	public boolean batchUpdate(List<CcsNode> nodes) throws Exception {
		return this.batchUpdate(nodes, nodes.size());
	}
}
