package com.bocloud.pms.repository;

import com.bocloud.common.model.Pager;
import com.bocloud.common.model.Param;
import com.bocloud.common.utils.MapTools;
import com.bocloud.database.core.intf.impl.BasicGenericDao;
import com.bocloud.database.utils.QueryBuilder;
import com.bocloud.pms.entity.CmsLog;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
 * 消息队列日志服务实现类
 */
@Repository("cmsLogRepository")
public class CmsLogRepository extends BasicGenericDao<CmsLog, Long> {

    public CmsLogRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate npJdbcTemplate) {
        super(jdbcTemplate, npJdbcTemplate);
    }

    public List<CmsLog> list(int page, int rows, List<Param> params, Map<String, String> sorter) throws Exception {
        String sql = "select a.* from cms_log a where 1 = 1 ";
        sql = QueryBuilder.buildRaw(sql, new Pager(page, rows, params, sorter), "a");
        Map<String, Object> paramMap = QueryBuilder.getParam(params);
        return this.list(CmsLog.class, sql, paramMap);
    }

    public int count(List<Param> params) throws Exception {
        String sql = "select count(1) from cms_log a where 1 = 1";
        sql = QueryBuilder.buildRaw(sql, params, null, "a");
        Map<String, Object> paramMap = QueryBuilder.getParam(params);
        return this.countQuery(sql, paramMap).intValue();
    }

//    public void batch(List<CmsLog> logs) throws Exception {
//        this.batchSave(logs, logs.size());
//    }

    public boolean deleteByMq(Long mqId) throws Exception {
        String sql = "delete from cms_log where mq_id = :mqId";
        Map<String, Object> params = MapTools.simpleMap("mqId", mqId);
        return this.execute(sql, params) > 0;
    }

}
