package com.bocloud.pms.repository;

import com.bocloud.common.utils.ListTool;
import com.bocloud.common.utils.MapTools;
import com.bocloud.database.core.intf.impl.BasicGenericDao;
import com.bocloud.pms.entity.CmsNode;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
 * 缓存节点Repository接口实现
 *
 * @author weiwei
 */
@Repository("cmsNodeRepository")
public class CmsNodeRepository extends BasicGenericDao<CmsNode, Long> {

    public CmsNodeRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate npJdbcTemplate) {
        super(jdbcTemplate, npJdbcTemplate);
    }

    public List<CmsNode> list(Long cmsId) throws Exception {
        String sql = "select * from cms_node where cms_id = :cmsId";
        Map<String, Object> params = MapTools.simpleMap("cmsId", cmsId);
        return this.list(CmsNode.class, sql, params);
    }

    public boolean deleteByCms(Long cmsId) throws Exception {
        String sql = "delete from cms_node where cms_id = :cmsId";
        Map<String, Object> params = MapTools.simpleMap("cmsId", cmsId);
        return this.execute(sql, params) > 0;
    }

    public CmsNode query(Long id) throws Exception {
        String sql = "select * from cms_node where id = :id";
        Map<String, Object> params = MapTools.simpleMap("id", id);
        List<CmsNode> list = this.list(CmsNode.class, sql, params);
        return ListTool.isEmpty(list) ? null : list.get(0);
    }

}
