package com.bocloud.pms.repository;

import com.bocloud.common.model.Pager;
import com.bocloud.common.model.Param;
import com.bocloud.common.utils.MapTools;
import com.bocloud.database.core.intf.impl.BasicGenericDao;
import com.bocloud.database.utils.QueryBuilder;
import com.bocloud.pms.entity.KvsLog;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
 * rds日志服务实现类
 */
@Repository("kvsLogRepository")
public class KvsLogRepository extends BasicGenericDao<KvsLog, Long> {

    public KvsLogRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate npJdbcTemplate) {
        super(jdbcTemplate, npJdbcTemplate);
    }

    public List<KvsLog> list(int page, int rows, List<Param> params, Map<String, String> sorter) throws Exception {
        String sql = "select a.* from kvs_log a where 1 = 1 ";
        sql = QueryBuilder.buildRaw(sql, new Pager(page, rows, params, sorter), "a");
        Map<String, Object> paramMap = QueryBuilder.getParam(params);
        return this.list(KvsLog.class, sql, paramMap);
    }

    public int count(List<Param> params) throws Exception {
        String sql = "select count(1) from kvs_log where 1 = 1";
        sql = QueryBuilder.buildRaw(sql, params, null, "");
        Map<String, Object> paramMap = QueryBuilder.getParam(params);
        return this.countQuery(sql, paramMap).intValue();
    }

    public void batch(List<KvsLog> logs) throws Exception {
        this.batchSave(logs, logs.size());
    }

    public boolean deleteByKvs(Long kvsId) throws Exception {
        String sql = "delete from kvs_param_log where kvs_id = :kvsId";
        Map<String, Object> params = MapTools.simpleMap("kvsId", kvsId);
        return this.execute(sql, params) > 0;
    }

}
