package com.bocloud.pms.repository;

import com.bocloud.common.utils.MapTools;
import com.bocloud.database.core.intf.impl.BasicGenericDao;
import com.bocloud.pms.entity.LbsNode;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
 * 负载节点Repository接口实现
 *
 * @author weiwei
 */
@Repository("lbsNodeRepository")
public class LbsNodeRepository extends BasicGenericDao<LbsNode, Long> {

	public LbsNodeRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate npJdbcTemplate) {
		super(jdbcTemplate, npJdbcTemplate);
	}

	public List<LbsNode> list(Long lbsId) throws Exception {
		String sql = "select * from lbs_node where lbs_id = :lbsId";
		Map<String, Object> params = MapTools.simpleMap("lbsId", lbsId);
		return this.list(LbsNode.class, sql, params);
	}

	public boolean deleteByLbs(Long lbsId) throws Exception {
		String sql = "delete from lbs_node where lbs_id = :lbsId";
		Map<String, Object> params = MapTools.simpleMap("lbsId", lbsId);
		return this.execute(sql, params) > 0;
	}

	public LbsNode query(Long id) throws Exception {
		String sql = "select * from lbs_node where id = :id";
		Map<String, Object> params = MapTools.simpleMap("id", id);
		List<LbsNode> list = this.list(LbsNode.class, sql, params);
		return list.isEmpty() ? null : list.get(0);
	}

	public boolean batchUpdate(List<LbsNode> nodes) throws Exception {
		return this.batchUpdate(nodes, nodes.size());
	}
}
