package com.bocloud.pms.repository;

import com.bocloud.common.utils.ListTool;
import com.bocloud.common.utils.MapTools;
import com.bocloud.database.core.intf.impl.BasicGenericDao;
import com.bocloud.pms.entity.RdsNode;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
 * 数据库节点Repository接口实现
 *
 * @author weiwei
 */
@Repository("rdsNodeRepository")
public class RdsNodeRepository extends BasicGenericDao<RdsNode, Long> {

    public RdsNodeRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate npJdbcTemplate) {
        super(jdbcTemplate, npJdbcTemplate);
    }

    public List<RdsNode> list(Long rdsId) throws Exception {
        String sql = "select * from rds_node where rds_id = :rdsId";
        Map<String, Object> params = MapTools.simpleMap("rdsId", rdsId);
        return this.list(RdsNode.class, sql, params);
    }

    public boolean deleteByRds(Long rdsId) throws Exception {
        String sql = "delete from rds_node where rds_id = :rdsId";
        Map<String, Object> params = MapTools.simpleMap("rdsId", rdsId);
        return this.execute(sql, params) > 0;
    }

    public RdsNode query(Long id) throws Exception {
        String sql = "select * from rds_node where id = :id";
        Map<String, Object> params = MapTools.simpleMap("id", id);
        List<RdsNode> list = this.list(RdsNode.class, sql, params);
        return ListTool.isEmpty(list) ? null : list.get(0);
    }

}
