package com.bocloud.pms.repository;

import com.bocloud.common.model.Pager;
import com.bocloud.common.model.Param;
import com.bocloud.common.utils.MapTools;
import com.bocloud.database.core.intf.impl.BasicGenericDao;
import com.bocloud.database.utils.QueryBuilder;
import com.bocloud.pms.entity.RdsParamLog;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
 * rds参数修改日志实现类
 */
@Repository("rdsParamLogRepository")
public class RdsParamLogRepository extends BasicGenericDao<RdsParamLog, Long> {

    public RdsParamLogRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate npJdbcTemplate) {
        super(jdbcTemplate, npJdbcTemplate);
    }

    public List<RdsParamLog> list(int page, int rows, List<Param> params, Map<String, String> sorter) throws Exception {
        String sql = "select a.* from rds_param_log a where 1 = 1 ";
        sql = QueryBuilder.buildRaw(sql, new Pager(page, rows, params, sorter), "a");
        Map<String, Object> paramMap = QueryBuilder.getParam(params);
        return this.list(RdsParamLog.class, sql, paramMap);
    }

    public int count(List<Param> params) throws Exception {
        String sql = "select count(1) from rds_param_log where 1 = 1";
        sql = QueryBuilder.buildRaw(sql, params, null, "");
        Map<String, Object> paramMap = QueryBuilder.getParam(params);
        return this.countQuery(sql, paramMap).intValue();
    }

    public void batch(List<RdsParamLog> logs) throws Exception {
        this.batchSave(logs, logs.size());
    }

    public boolean deleteByRds(Long rdsId) throws Exception {
        String sql = "delete from rds_param_log where rds_id = :rdsId";
        Map<String, Object> params = MapTools.simpleMap("rdsId", rdsId);
        return this.execute(sql, params) > 0;
    }

}
