package com.bocloud.pms.service;

import com.bocloud.pms.interfaces.middleware.CmsNodeService;
import com.bocloud.pms.repository.CmsNodeRepository;
import com.bocloud.pms.repository.CmsRepository;
import com.bocloud.service.core.RegistryService;
import com.bocloud.service.http.core.ServiceFactory;
import com.bocloud.service.lock.LockFactory;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("cmsNodeService")
public class CmsNodeServiceImpl implements CmsNodeService {

	private static Logger logger = LoggerFactory.getLogger(CmsNodeServiceImpl.class);
	@Autowired
	private LockFactory lockFactory;
	@Autowired
	private RegistryService registryService;
	@Autowired
	private ServiceFactory serviceFactory;
	@Autowired
	private CmsNodeRepository cmsNodeRepository;
	@Autowired
	private CmsRepository cmsRepository;
//	@Autowired
//	private CloudServerRepository cloudServerRepository;

//	@Override
//	public BocloudResult start(Long id, RequestContext context) {
//		String path = CmsNode.class.getSimpleName() + "_" + id;
//		CmsNode node = null;
//		try (BocloudACLock lock = lockFactory.getACLock(path)) {
//			Assert.isTrue(lock.acquire(10, TimeUnit.SECONDS), "请求超时");
//			node = cmsNodeRepository.query(id);
//			if (null == node) {
//				logger.warn("cms node data not exist");
//				return new BocloudResult(false, "数据不存在");
//			}
//			if (BocloudStatus.Server.RUNNING.name().equalsIgnoreCase(node.getStatus())) {
//				return new BocloudResult(false, node.getCmsId(), "处于运行状态无法开启");
//			}
//			Cms cms = cmsRepository.query(node.getCmsId());
//			if (null == cms) {
//				logger.warn("cms not exist");
//				return new BocloudResult(false, "消息队列不存在");
//			}
//			CloudServer server = cloudServerRepository.getByInstanceId(node.getInstanceId());
//			if (null == server) {
//				logger.warn("CloudServer data not exist");
//				return new BocloudResult(false, node.getCmsId(), "数据不存在");
//			}
//			BocloudResult result = MDSUtils.invoke(serviceFactory, registryService, MDSUtils.getParam(server,
//					MDSUtils.getService(cms.getType(), null), MDSUtils.START, OSCategory.LINUX));
//			if (result.isFailed()) {
//				logger.error("消息队列开启失败", result.getData());
//				return new BocloudResult(false, node.getCmsId(), "消息队列开启失败");
//			}
//			node.setStatus(BocloudStatus.Server.RUNNING.name());
//			cmsNodeRepository.update(node);
//			List<CmsNode> cmsNodes = cmsNodeRepository.list(cms.getId());
//			int statusCount = MDSUtils.statusCount(cmsNodes, BocloudStatus.Server.RUNNING.name());
//			if (0 == statusCount) {
//				cms.setStatus(BocloudStatus.Server.STOPPED.name());
//			} else if (statusCount == cmsNodes.size()) {
//				cms.setStatus(BocloudStatus.Server.RUNNING.name());
//			} else {
//				cms.setStatus(BocloudStatus.Server.EXCEPTION.name());
//			}
//			cms.setMenderId(context.getTarget());
//			cms.setGmtModify(new Date());
//			cmsRepository.update(cms);
//			return new BocloudResult(true, node.getCmsId(), "消息队列开启成功");
//		} catch (Exception e) {
//			logger.error("start cms node failure:", e);
//			return new BocloudResult(false, null == node ? null : node.getCmsId(), "消息队列开启失败");
//		}
//	}
//
//	@Override
//	public BocloudResult stop(Long id, RequestContext context) {
//		String path = CmsNode.class.getSimpleName() + "_" + id;
//		CmsNode node = null;
//		try (BocloudACLock lock = lockFactory.getACLock(path)) {
//			Assert.isTrue(lock.acquire(10, TimeUnit.SECONDS), "请求超时");
//			node = cmsNodeRepository.query(id);
//			if (null == node) {
//				logger.warn("cms node data not exist");
//				return new BocloudResult(false, "数据不存在");
//			}
//			if (BocloudStatus.Server.STOPPED.name().equalsIgnoreCase(node.getStatus())) {
//				return new BocloudResult(false, node.getCmsId(), "处于关闭状态无法关闭");
//			}
//			Cms cms = cmsRepository.query(node.getCmsId());
//			if (null == cms) {
//				logger.warn("cms not exist");
//				return new BocloudResult(false, "消息队列不存在");
//			}
//			CloudServer server = cloudServerRepository.getByInstanceId(node.getInstanceId());
//			if (null == server) {
//				logger.warn("CloudServer data not exist");
//				return new BocloudResult(false, node.getCmsId(), "数据不存在");
//			}
//			// 给mq加锁，防止有其他操作在执行
//			try (BocloudACLock acLock = lockFactory.getACLock(Cms.class.getSimpleName() + "_" + node.getCmsId())) {
//				Assert.isTrue(acLock.acquire(10, TimeUnit.SECONDS), "请求超时");
//				BocloudResult result = MDSUtils.invoke(serviceFactory, registryService, MDSUtils.getParam(server,
//						MDSUtils.getService(cms.getType(), null), MDSUtils.STOP, OSCategory.LINUX));
//				if (result.isFailed()) {
//					logger.error("消息队列关闭失败", result.getMessage());
//					return new BocloudResult(false, node.getCmsId(), "消息队列关闭失败");
//				}
//				node.setStatus(BocloudStatus.Server.STOPPED.name());
//				cmsNodeRepository.update(node);
//				List<CmsNode> cmsNodes = cmsNodeRepository.list(cms.getId());
//				int statusCount = MDSUtils.statusCount(cmsNodes, BocloudStatus.Server.RUNNING.name());
//				if (0 == statusCount) {
//					cms.setStatus(BocloudStatus.Server.STOPPED.name());
//				} else if (statusCount == cmsNodes.size()) {
//					cms.setStatus(BocloudStatus.Server.RUNNING.name());
//				} else {
//					cms.setStatus(BocloudStatus.Server.EXCEPTION.name());
//				}
//				cms.setMenderId(context.getTarget());
//				cms.setGmtModify(new Date());
//				cmsRepository.update(cms);
//				return new BocloudResult(true, node.getCmsId(), "消息队列关闭成功");
//			} catch (Exception e) {
//				logger.error("stop rds node failure:", e);
//				return new BocloudResult(false, null == node ? null : node.getCmsId(), "消息队列关闭失败");
//			}
//		} catch (Exception e) {
//			logger.error("stop cms node failure:", e);
//			return new BocloudResult(false, null == node ? null : node.getCmsId(), "消息队列关闭失败");
//		}
//	}
//
//	@Override
//	public BocloudResult restart(Long id, RequestContext context) {
//		String path = CmsNode.class.getSimpleName() + "_" + id;
//		CmsNode node = null;
//		try (BocloudACLock lock = lockFactory.getACLock(path)) {
//			Assert.isTrue(lock.acquire(10, TimeUnit.SECONDS), "请求超时");
//			node = cmsNodeRepository.query(id);
//			if (null == node) {
//				logger.warn("cms node data not exist");
//				return new BocloudResult(false, "数据不存在");
//			}
//			CloudServer server = cloudServerRepository.getByInstanceId(node.getInstanceId());
//			if (null == server) {
//				logger.warn("CloudServer data not exist");
//				return new BocloudResult(false, node.getCmsId(), "数据不存在");
//			}
//			// 给mq加锁，防止有其他操作在执行
//			try (BocloudACLock acLock = lockFactory.getACLock(Cms.class.getSimpleName() + "_" + node.getCmsId())) {
//				Assert.isTrue(acLock.acquire(10, TimeUnit.SECONDS), "请求超时");
//				Cms cms = cmsRepository.query(node.getCmsId());
//				if (null == cms) {
//					logger.warn("cms not exist");
//					return new BocloudResult(false, "消息队列不存在");
//				}
//				BocloudResult result = MDSUtils.invoke(serviceFactory, registryService, MDSUtils.getParam(server,
//						MDSUtils.getService(cms.getType(), null), MDSUtils.RESTART, OSCategory.LINUX));
//				if (result.isFailed()) {
//					logger.error("消息队列重启失败", result.getData());
//					return new BocloudResult(false, node.getCmsId(), "消息队列重启失败");
//				}
//				node.setStatus(BocloudStatus.Server.RUNNING.name());
//				cmsNodeRepository.update(node);
//				List<CmsNode> cmsNodes = cmsNodeRepository.list(cms.getId());
//				int statusCount = MDSUtils.statusCount(cmsNodes, BocloudStatus.Server.RUNNING.name());
//				if (0 == statusCount) {
//					cms.setStatus(BocloudStatus.Server.STOPPED.name());
//				} else if (statusCount == cmsNodes.size()) {
//					cms.setStatus(BocloudStatus.Server.RUNNING.name());
//				} else {
//					cms.setStatus(BocloudStatus.Server.EXCEPTION.name());
//				}
//				cms.setMenderId(context.getTarget());
//				cms.setGmtModify(new Date());
//				cmsRepository.update(cms);
//				return new BocloudResult(true, node.getCmsId(), "消息队列重启成功");
//			} catch (Exception e) {
//				logger.error("stop rds node failure:", e);
//				return new BocloudResult(false, null == node ? null : node.getCmsId(), "消息队列重启失败");
//			}
//		} catch (Exception e) {
//			logger.error("restart cms node failure:", e);
//			return new BocloudResult(false, null == node ? null : node.getCmsId(), "消息队列重启失败");
//		}
//	}

}
