package com.bocloud.pms.service;

import com.bocloud.pms.interfaces.middleware.KvsNodeService;
import com.bocloud.pms.repository.KvsNodeRepository;
import com.bocloud.pms.repository.KvsRepository;
import com.bocloud.service.core.RegistryService;
import com.bocloud.service.http.core.ServiceFactory;
import com.bocloud.service.lock.LockFactory;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("kvsNodeService")
public class KvsNodeServiceImpl implements KvsNodeService {

    private static Logger logger = LoggerFactory.getLogger(KvsNodeServiceImpl.class);
    @Autowired
    private LockFactory lockFactory;
    @Autowired
    private RegistryService registryService;
    @Autowired
    private ServiceFactory serviceFactory;
    @Autowired
    private KvsRepository kvsRepository;
    @Autowired
    private KvsNodeRepository kvsNodeRepository;
//    @Autowired
//    private CloudServerRepository cloudServerRepository;

//    @Override
//    public BocloudResult start(Long id, RequestContext context) {
//        String path = KvsNode.class.getSimpleName() + "_" + id;
//        KvsNode node = null;
//        try (BocloudACLock lock = lockFactory.getACLock(path)) {
//            Assert.isTrue(lock.acquire(10, TimeUnit.SECONDS), "请求超时");
//            node = kvsNodeRepository.query(id);
//            if (null == node) {
//                logger.warn("kvs node data not exist");
//                return new BocloudResult(false, "数据不存在");
//            }
//            if (BocloudStatus.Server.RUNNING.name().equalsIgnoreCase(node.getStatus())) {
//                return new BocloudResult(false, node.getKvsId(), "处于运行状态无法开启");
//            }
//            Kvs kvs = kvsRepository.query(node.getKvsId());
//            if (null == kvs) {
//                logger.warn("kvs not exist");
//                return new BocloudResult(false, "数据库不存在");
//            }
//            CloudServer server = cloudServerRepository.getByInstanceId(node.getInstanceId());
//            if (null == server) {
//                logger.warn("CloudServer data not exist");
//                return new BocloudResult(false, node.getKvsId(), "数据不存在");
//            }
//            BocloudResult result = MDSUtils.invoke(serviceFactory, registryService, MDSUtils.getParam(server,
//                    MDSUtils.getService(kvs.getType(), null), MDSUtils.START, OSCategory.LINUX));
//            if (result.isFailed()) {
//                logger.error("数据库开启失败", result.getData());
//                return new BocloudResult(false, node.getKvsId(), "数据库开启失败");
//            }
//            node.setStatus(BocloudStatus.Server.RUNNING.name());
//            kvsNodeRepository.update(node);
//            List<KvsNode> nodes = kvsNodeRepository.list(kvs.getId());
//            String message = "数据库开启成功";
//            if ("cluster".equals(kvs.getCategory())) {
//                if (ResourceCategory.MongoDB.name().equalsIgnoreCase(kvs.getType())) {
//                    Thread.sleep(3000);
//                    result = executeMongod(kvs, nodes);
//                    if (result.isSuccess()) {
//                        JSONObject object = JSONObject.parseObject(JSONObject.toJSONString(result.getData()));
//                        JSONArray members = object.getJSONArray("members");
//                        nodes = synchrodata(members, nodes, kvs);
//                        if (!ListTool.isEmpty(nodes)) {
//                            kvsNodeRepository.batchUpdate(nodes);
//                        }
//                    } else {
//                        message = "开启成功，但集群服务不可用，请尝试开启其他节点服务！";
//                    }
//                }
//                // 复查得到最新的节点状态
//                nodes = kvsNodeRepository.list(kvs.getId());
//            }
//            int statusCount = MDSUtils.statusCount(nodes, BocloudStatus.Server.RUNNING.name());
//            if (0 == statusCount) {
//                kvs.setStatus(BocloudStatus.Server.STOPPED.name());
//            } else if (statusCount == nodes.size()) {
//                kvs.setStatus(BocloudStatus.Server.RUNNING.name());
//            } else {
//                kvs.setStatus(BocloudStatus.Server.EXCEPTION.name());
//            }
//            kvs.setMenderId(context.getTarget());
//            kvs.setGmtModify(new Date());
//            kvsRepository.update(kvs);
//            return new BocloudResult(true, node.getKvsId(), message);
//        } catch (Exception e) {
//            logger.error("start kvs node failure:", e);
//            return new BocloudResult(false, null == node ? null : node.getKvsId(), "数据库开启失败");
//        }
//    }
//
//    /**
//     * 同步数据，得到需要变更角色的节点信息
//     *
//     * @param member
//     * @param nodes
//     * @param kvs
//     * @return
//     */
//    private List<KvsNode> synchrodata(JSONArray member, List<KvsNode> nodes, Kvs kvs) {
//        Map<String, KvsNode> nodeMap = Maps.newHashMap();
//        for (KvsNode node : nodes) {
//            nodeMap.put(node.getManageIp(), node);
//        }
//        List<KvsNode> kvsNoes = Lists.newArrayList();
//        for (Object object : member) {
//            JSONObject nodeData = JSONObject.parseObject(String.valueOf(object));
//            String name = StringUtils.substringBefore(nodeData.getString("name"), ":");
//            String stateStr = nodeData.getString("stateStr");
//            String status = BocloudStatus.Server.RUNNING.name();
//            switch (stateStr) {
//                case "SECONDARY":
//                    stateStr = "replicas";
//                    break;
//                case "PRIMARY":
//                    stateStr = "master";
//                    kvs.setManageIp(name);
//                    kvs.setAddress(name);
//                    break;
//                case "ARBITER":
//                    stateStr = "arbiter";
//                    break;
//                default:
//                    stateStr = "(not reachable/healthy)";
//                    status = BocloudStatus.Server.STOPPED.name();
//                    break;
//            }
//            if (!nodeMap.containsKey(name)) {
//                continue;
//            }
//            KvsNode node = nodeMap.get(name);
//            if (!stateStr.equals(node.getRole()) || !status.equalsIgnoreCase(node.getStatus())) {
//                node.setStatus(status);
//                node.setRole(stateStr);
//            }
//            kvsNoes.add(node);
//        }
//        return kvsNoes;
//    }
//
//    private BocloudResult executeMongod(Kvs kvs, List<KvsNode> nodes) {
//        MongoClient client = null;
//        try {
//            List<ServerAddress> addresses = Lists.newArrayList();
//            int port = "cluster".equals(kvs.getCategory()) ? 27017 + 11111 : 27017;
//            for (KvsNode node : nodes) {
//                addresses.add(new ServerAddress(node.getManageIp(), port));
//            }
//            MongoCredential credential = MongoCredential.createScramSha1Credential(kvs.getUsername(), "admin",
//                    MDSUtils.decrypt(kvs.getPassword()).toCharArray());
//            MongoClientOptions.Builder builder = MongoClientOptions.builder();
//            builder.readPreference(ReadPreference.secondaryPreferred());
//            MongoClientOptions options = builder.build();
//            client = new MongoClient(addresses, credential, options);
//            MongoDatabase database = client.getDatabase("admin");
//            Document doc = new Document();
//            doc.append("replSetGetStatus", 1);
//            doc.append("initialSync", 1);
//            return new BocloudResult(true, database.runCommand(doc), "数据库查询成功");
//        } catch (Exception e) {
//            logger.info("connect mongodb error:", e);
//            return new BocloudResult(false, "数据库查询失败");
//        } finally {
//            if (null != client) {
//                client.close();
//            }
//        }
//    }
//
//    @Override
//    public BocloudResult stop(Long id, RequestContext context) {
//        String path = KvsNode.class.getSimpleName() + "_" + id;
//        KvsNode node = null;
//        try (BocloudACLock lock = lockFactory.getACLock(path)) {
//            Assert.isTrue(lock.acquire(10, TimeUnit.SECONDS), "请求超时");
//            node = kvsNodeRepository.query(id);
//            if (null == node) {
//                logger.warn("kvs node data not exist");
//                return new BocloudResult(false, "数据不存在");
//            }
//            if (BocloudStatus.Server.STOPPED.name().equalsIgnoreCase(node.getStatus())) {
//                return new BocloudResult(false, node.getKvsId(), "处于关闭状态无法关闭");
//            }
//            Kvs kvs = kvsRepository.query(node.getKvsId());
//            if (null == kvs) {
//                logger.warn("kvs not exist");
//                return new BocloudResult(false, "数据库不存在");
//            }
//            CloudServer server = cloudServerRepository.getByInstanceId(node.getInstanceId());
//            if (null == server) {
//                logger.warn("CloudServer data not exist");
//                return new BocloudResult(false, node.getKvsId(), "数据不存在");
//            }
//            // 给kvs加锁，防止有其他操作在执行
//            try (BocloudACLock acLock = lockFactory.getACLock(Kvs.class.getSimpleName() + "_" + node.getKvsId())) {
//                Assert.isTrue(acLock.acquire(10, TimeUnit.SECONDS), "请求超时");
//                BocloudResult result = MDSUtils.invoke(serviceFactory, registryService, MDSUtils.getParam(server,
//                        MDSUtils.getService(kvs.getType(), null), MDSUtils.STOP, OSCategory.LINUX));
//                if (result.isFailed()) {
//                    logger.error("数据库关闭失败", result.getData());
//                    return new BocloudResult(false, node.getKvsId(), "数据库关闭失败");
//                }
//                node.setStatus(BocloudStatus.Server.STOPPED.name());
//                kvsNodeRepository.update(node);
//                List<KvsNode> nodes = kvsNodeRepository.list(kvs.getId());
//                String message = "数据库关闭成功";
//                if ("cluster".equals(kvs.getCategory())) {
//                    if (ResourceCategory.MongoDB.name().equalsIgnoreCase(kvs.getType())) {
//                        result = executeMongod(kvs, nodes);
//                        if (result.isSuccess()) {
//                            JSONObject object = JSONObject.parseObject(JSONObject.toJSONString(result.getData()));
//                            JSONArray members = object.getJSONArray("members");
//                            nodes = synchrodata(members, nodes, kvs);
//                            if (!ListTool.isEmpty(nodes)) {
//                                kvsNodeRepository.batchUpdate(nodes);
//                            }
//                        } else {
//                            message = "关闭成功，但集群服务不可用，请尝试开启其他节点服务！";
//                        }
//                    }
//                    // 复查得到最新的节点状态
//                    nodes = kvsNodeRepository.list(kvs.getId());
//                }
//                int statusCount = MDSUtils.statusCount(nodes, BocloudStatus.Server.RUNNING.name());
//                if (0 == statusCount) {
//                    kvs.setStatus(BocloudStatus.Server.STOPPED.name());
//                } else if (statusCount == nodes.size()) {
//                    kvs.setStatus(BocloudStatus.Server.RUNNING.name());
//                } else {
//                    kvs.setStatus(BocloudStatus.Server.EXCEPTION.name());
//                }
//                kvs.setMenderId(context.getTarget());
//                kvs.setGmtModify(new Date());
//                kvsRepository.update(kvs);
//                return new BocloudResult(true, node.getKvsId(), message);
//            } catch (Exception e) {
//                logger.error("stop kvs node failure:", e);
//                return new BocloudResult(false, null == node ? null : node.getKvsId(), "数据库关闭失败");
//            }
//        } catch (Exception e) {
//            logger.error("stop kvs node failure:", e);
//            return new BocloudResult(false, null == node ? null : node.getKvsId(), "数据库关闭失败");
//        }
//    }
//
//    @Override
//    public BocloudResult restart(Long id, RequestContext context) {
//        String path = KvsNode.class.getSimpleName() + "_" + id;
//        KvsNode node = null;
//        try (BocloudACLock lock = lockFactory.getACLock(path)) {
//            Assert.isTrue(lock.acquire(10, TimeUnit.SECONDS), "请求超时");
//            node = kvsNodeRepository.query(id);
//            if (null == node) {
//                logger.warn("kvs node data not exist");
//                return new BocloudResult(false, "数据不存在");
//            }
//            CloudServer server = cloudServerRepository.getByInstanceId(node.getInstanceId());
//            if (null == server) {
//                logger.warn("CloudServer data not exist");
//                return new BocloudResult(false, node.getKvsId(), "数据不存在");
//            }
//            // 给kvs加锁，防止有其他操作在执行
//            try (BocloudACLock acLock = lockFactory.getACLock(Kvs.class.getSimpleName() + "_" + node.getKvsId())) {
//                Assert.isTrue(acLock.acquire(10, TimeUnit.SECONDS), "请求超时");
//                Kvs kvs = kvsRepository.query(node.getKvsId());
//                if (null == kvs) {
//                    logger.warn("kvs not exist");
//                    return new BocloudResult(false, "数据库不存在");
//                }
//                BocloudResult result = MDSUtils.invoke(serviceFactory, registryService, MDSUtils.getParam(server,
//                        MDSUtils.getService(kvs.getType(), null), MDSUtils.RESTART, OSCategory.LINUX));
//                if (result.isFailed()) {
//                    logger.error("数据库重启失败", result.getData());
//                    return new BocloudResult(false, node.getKvsId(), "数据库重启失败");
//                }
//                node.setStatus(BocloudStatus.Server.STOPPED.name());
//                kvsNodeRepository.update(node);
//                List<KvsNode> nodes = kvsNodeRepository.list(kvs.getId());
//                String message = "数据库重启成功";
//                if ("cluster".equals(kvs.getCategory())) {
//                    if (ResourceCategory.MongoDB.name().equalsIgnoreCase(kvs.getType())) {
//                        result = executeMongod(kvs, nodes);
//                        if (result.isSuccess()) {
//                            JSONObject object = JSONObject.parseObject(JSONObject.toJSONString(result.getData()));
//                            JSONArray members = object.getJSONArray("members");
//                            nodes = synchrodata(members, nodes, kvs);
//                            if (!ListTool.isEmpty(nodes)) {
//                                kvsNodeRepository.batchUpdate(nodes);
//                            }
//                        } else {
//                            message = "重启成功，但集群服务不可用，请尝试开启其他节点服务！";
//                        }
//                    }
//                    // 复查得到最新的节点状态
//                    nodes = kvsNodeRepository.list(kvs.getId());
//                }
//                int statusCount = MDSUtils.statusCount(nodes, BocloudStatus.Server.RUNNING.name());
//                if (0 == statusCount) {
//                    kvs.setStatus(BocloudStatus.Server.STOPPED.name());
//                } else if (statusCount == nodes.size()) {
//                    kvs.setStatus(BocloudStatus.Server.RUNNING.name());
//                } else {
//                    kvs.setStatus(BocloudStatus.Server.EXCEPTION.name());
//                }
//                kvs.setMenderId(context.getTarget());
//                kvs.setGmtModify(new Date());
//                kvsRepository.update(kvs);
//                return new BocloudResult(true, node.getKvsId(), message);
//            } catch (Exception e) {
//                logger.error("restart kvs node failure:", e);
//                return new BocloudResult(false, null == node ? null : node.getKvsId(), "数据库重启失败");
//            }
//        } catch (Exception e) {
//            logger.error("restart kvs node failure:", e);
//            return new BocloudResult(false, null == node ? null : node.getKvsId(), "数据库重启失败");
//        }
//    }

}
