package com.bocloud.pms.service;

import com.bocloud.pms.interfaces.middleware.RdsNodeService;
import com.bocloud.pms.repository.RdsNodeRepository;
import com.bocloud.pms.repository.RdsRepository;
import com.bocloud.service.core.RegistryService;
import com.bocloud.service.http.core.ServiceFactory;
import com.bocloud.service.lock.LockFactory;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("rdsNodeService")
public class RdsNodeServiceImpl implements RdsNodeService {

    private static Logger logger = LoggerFactory.getLogger(RdsNodeServiceImpl.class);
    @Autowired
    private LockFactory lockFactory;
    @Autowired
    private RegistryService registryService;
    @Autowired
    private ServiceFactory serviceFactory;
    @Autowired
    private RdsRepository rdsRepository;
    @Autowired
    private RdsNodeRepository rdsNodeRepository;
//    @Autowired
//    private CloudServerRepository cloudServerRepository;

//    @Override
//    public BocloudResult start(Long id, RequestContext context) {
//        String path = RdsNode.class.getSimpleName() + "_" + id;
//        RdsNode node = null;
//        try (BocloudACLock lock = lockFactory.getACLock(path)) {
//            Assert.isTrue(lock.acquire(10, TimeUnit.SECONDS), "请求超时");
//            node = rdsNodeRepository.query(id);
//            if (null == node) {
//                logger.warn("rds node data not exist");
//                return new BocloudResult(false, "数据不存在");
//            }
//            if (BocloudStatus.Server.RUNNING.name().equalsIgnoreCase(node.getStatus())) {
//                return new BocloudResult(false, node.getRdsId(), "处于运行状态无法开启");
//            }
//            Rds rds = rdsRepository.query(node.getRdsId());
//            if (null == rds) {
//                logger.warn("rds not exist");
//                return new BocloudResult(false, "数据库不存在");
//            }
//            CloudServer server = cloudServerRepository.getByInstanceId(node.getInstanceId());
//            if (null == server) {
//                logger.warn("CloudServer data not exist");
//                return new BocloudResult(false, node.getRdsId(), "数据不存在");
//            }
//            OSCategory category = OSCategory.LINUX;
//            if (ResourceCategory.SqlServer.name().equalsIgnoreCase(rds.getType())) {
//                category = OSCategory.WINDOWS;
//            }
//            BocloudResult result = MDSUtils.invoke(this.serviceFactory, this.registryService, MDSUtils.getParam(server,
//                    MDSUtils.getService(rds.getType(), rds.getVersion()), MDSUtils.START, category));
//            if (result.isFailed()) {
//                return new BocloudResult(false, node.getRdsId(), "数据库开启失败");
//            }
//            node.setStatus(BocloudStatus.Server.RUNNING.name());
//            rdsNodeRepository.update(node);
//            List<RdsNode> rdsNodes = rdsNodeRepository.list(rds.getId());
//            int statusCount = MDSUtils.statusCount(rdsNodes, BocloudStatus.Server.RUNNING.name());
//            if (0 == statusCount) {
//                rds.setStatus(BocloudStatus.Server.STOPPED.name());
//            } else if (statusCount == rdsNodes.size()) {
//                rds.setStatus(BocloudStatus.Server.RUNNING.name());
//            } else {
//                rds.setStatus(BocloudStatus.Server.EXCEPTION.name());
//            }
//            rds.setMenderId(context.getTarget());
//            rds.setGmtModify(new Date());
//            rdsRepository.update(rds);
//            return new BocloudResult(true, node.getRdsId(), "数据库开启成功");
//        } catch (Exception e) {
//            logger.error("start rds node failure:", e);
//            return new BocloudResult(false, null == node ? null : node.getRdsId(), "数据库开启失败");
//        }
//    }
//
//    @Override
//    public BocloudResult stop(Long id, RequestContext context) {
//        String path = RdsNode.class.getSimpleName() + "_" + id;
//        RdsNode node = null;
//        try (BocloudACLock lock = lockFactory.getACLock(path)) {
//            Assert.isTrue(lock.acquire(10, TimeUnit.SECONDS), "请求超时");
//            node = rdsNodeRepository.query(id);
//            if (null == node) {
//                logger.warn("rds node data not exist");
//                return new BocloudResult(false, "数据不存在");
//            }
//            if (BocloudStatus.Server.STOPPED.name().equalsIgnoreCase(node.getStatus())) {
//                return new BocloudResult(false, node.getRdsId(), "处于关闭状态无法关闭");
//            }
//            Rds rds = rdsRepository.query(node.getRdsId());
//            if (null == rds) {
//                logger.warn("rds not exist");
//                return new BocloudResult(false, "数据库不存在");
//            }
//            CloudServer server = cloudServerRepository.getByInstanceId(node.getInstanceId());
//            if (null == server) {
//                logger.warn("CloudServer data not exist");
//                return new BocloudResult(false, node.getRdsId(), "数据不存在");
//            }
//            // 给rds加锁，防止有其他操作在执行
//            try (BocloudACLock acLock = lockFactory.getACLock(Rds.class.getSimpleName() + "_" + node.getRdsId())) {
//                Assert.isTrue(acLock.acquire(10, TimeUnit.SECONDS), "请求超时");
//                OSCategory category = OSCategory.LINUX;
//                if (ResourceCategory.SqlServer.name().equalsIgnoreCase(rds.getType())) {
//                    category = OSCategory.WINDOWS;
//                }
//                BocloudResult result = MDSUtils.invoke(this.serviceFactory, this.registryService, MDSUtils.getParam(
//                        server, MDSUtils.getService(rds.getType(), rds.getVersion()), MDSUtils.STOP, category));
//                if (result.isFailed()) {
//                    return new BocloudResult(false, node.getRdsId(), "数据库关闭失败");
//                }
//                node.setStatus(BocloudStatus.Server.STOPPED.name());
//                rdsNodeRepository.update(node);
//                List<RdsNode> rdsNodes = rdsNodeRepository.list(rds.getId());
//                int statusCount = MDSUtils.statusCount(rdsNodes, BocloudStatus.Server.RUNNING.name());
//                if (0 == statusCount) {
//                    rds.setStatus(BocloudStatus.Server.STOPPED.name());
//                } else if (statusCount == rdsNodes.size()) {
//                    rds.setStatus(BocloudStatus.Server.RUNNING.name());
//                } else {
//                    rds.setStatus(BocloudStatus.Server.EXCEPTION.name());
//                }
//                rds.setMenderId(context.getTarget());
//                rds.setGmtModify(new Date());
//                rdsRepository.update(rds);
//                return new BocloudResult(true, node.getRdsId(), "数据库关闭成功");
//            } catch (Exception e) {
//                logger.error("stop rds node failure:", e);
//                return new BocloudResult(false, null == node ? null : node.getRdsId(), "数据库关闭失败");
//            }
//        } catch (Exception e) {
//            logger.error("stop rds node failure:", e);
//            return new BocloudResult(false, null == node ? null : node.getRdsId(), "数据库关闭失败");
//        }
//    }
//
//    @Override
//    public BocloudResult restart(Long id, RequestContext context) {
//        String path = RdsNode.class.getSimpleName() + "_" + id;
//        RdsNode node = null;
//        try (BocloudACLock lock = lockFactory.getACLock(path)) {
//            Assert.isTrue(lock.acquire(10, TimeUnit.SECONDS), "请求超时");
//            node = rdsNodeRepository.query(id);
//            if (null == node) {
//                logger.warn("rds node data not exist");
//                return new BocloudResult(false, "数据不存在");
//            }
//            CloudServer server = cloudServerRepository.getByInstanceId(node.getInstanceId());
//            if (null == server) {
//                logger.warn("CloudServer data not exist");
//                return new BocloudResult(false, node.getRdsId(), "数据不存在");
//            }
//            // 给rds加锁，防止有其他操作在执行
//            try (BocloudACLock acLock = lockFactory.getACLock(Rds.class.getSimpleName() + "_" + node.getRdsId())) {
//                Assert.isTrue(acLock.acquire(10, TimeUnit.SECONDS), "请求超时");
//                Rds rds = rdsRepository.query(node.getRdsId());
//                if (null == rds) {
//                    logger.warn("rds not exist");
//                    return new BocloudResult(false, "数据库不存在");
//                }
//                OSCategory category = OSCategory.LINUX;
//                if (ResourceCategory.SqlServer.name().equalsIgnoreCase(rds.getType())) {
//                    category = OSCategory.WINDOWS;
//                }
//                BocloudResult result = MDSUtils.invoke(serviceFactory, this.registryService, MDSUtils.getParam(server,
//                        MDSUtils.getService(rds.getType(), rds.getVersion()), MDSUtils.RESTART, category));
//                if (result.isFailed()) {
//                    return new BocloudResult(false, node.getRdsId(), "数据库重启失败");
//                }
//                node.setStatus(BocloudStatus.Server.RUNNING.name());
//                rdsNodeRepository.update(node);
//                List<RdsNode> rdsNodes = rdsNodeRepository.list(rds.getId());
//                int statusCount = MDSUtils.statusCount(rdsNodes, BocloudStatus.Server.RUNNING.name());
//                if (0 == statusCount) {
//                    rds.setStatus(BocloudStatus.Server.STOPPED.name());
//                } else if (statusCount == rdsNodes.size()) {
//                    rds.setStatus(BocloudStatus.Server.RUNNING.name());
//                } else {
//                    rds.setStatus(BocloudStatus.Server.EXCEPTION.name());
//                }
//                rds.setMenderId(context.getTarget());
//                rds.setGmtModify(new Date());
//                rdsRepository.update(rds);
//                return new BocloudResult(true, node.getRdsId(), "数据库重启成功");
//            } catch (Exception e) {
//                logger.error("stop rds node failure:", e);
//                return new BocloudResult(false, null == node ? null : node.getRdsId(), "数据库重启失败");
//            }
//        } catch (Exception e) {
//            logger.error("stop rds node failure:", e);
//            return new BocloudResult(false, null == node ? null : node.getRdsId(), "数据库重启失败");
//        }
//    }

}
