package com.bocloud.pms.service.internal;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.common.enums.BoCloudMethod;
import com.bocloud.common.enums.BoCloudService;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.common.model.BocloudToken;
import com.bocloud.common.utils.Common;
import com.bocloud.common.utils.MapTools;
import com.bocloud.service.core.CurrentService;
import com.bocloud.service.core.Service;
import com.bocloud.service.http.core.ServiceFactory;
import com.bocloud.service.http.model.RemoteService;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.Map;

/**
 * ip操作调用ims类
 *
 * @author lyy
 * @version 1.0
 * @date 2020/12/17 11:00
 */
@Component
public class ImsIpService implements InitializingBean {
    @Autowired
    private ServiceFactory serviceFactory;
    @Autowired
    private CurrentService currentService;
    private static Service service = Service.create(BoCloudService.IMS);
    private Map<String, Object> headers = new HashMap<>(4);

    public BocloudResult deleteBySubnetId(String ip, Long subnetId) {
        JSONObject object = new JSONObject();
        object.put("ip", ip);
        object.put("subnetId", subnetId);
        Map<String, Object> paramMap = MapTools.simpleMap(Common.PARAMS, object);
        RemoteService remoteService = serviceFactory.build(service, "/v1/ips/subnets", BoCloudMethod.DELETE, headers,
                paramMap);
        return remoteService.invoke();
    }

    @Override
    public void afterPropertiesSet() throws Exception {
        this.headers.put(BocloudToken.INTERNAL_TOKEN, currentService.getToken());
        this.headers.put("source", currentService.getService().getName());
    }
}
